package com.gles.view.base.math;

import java.util.ArrayList;


public class BezierUtil {
	static ArrayList<BNPosition> al = new ArrayList<BNPosition>(); // ߻ڵĵб

	public static ArrayList<BNPosition> getBezierData(float span)// ϵ
	{
		ArrayList<BNPosition> result = new ArrayList<BNPosition>(); // űϵĽб

		int n = al.size() - 1;

		if (n < 1) // ڵĵ1ޱ
		{
			return result;
		}

		int steps = (int) (1.0f / span); // ܵò
		long[] jiechengNA = new long[n + 1]; // һΪn+1Ľ׳

		for (int i = 0; i <= n; i++) { // 0nĽ׳
			jiechengNA[i] = jiecheng(i);
		}

		for (int i = 0; i <= steps; i++) {
			float t = i * span;
			if (t > 1) // tֵ0-1֮
			{
				t = 1;
			}
			float xf = 0;
			float yf = 0;

			float[] tka = new float[n + 1];
			float[] otka = new float[n + 1];
			for (int j = 0; j <= n; j++) {
				tka[j] = (float) Math.pow(t, j); // tj
				otka[j] = (float) Math.pow(1 - t, j); // 1-tj
			}

			for (int k = 0; k <= n; k++) {
				float xs = (jiechengNA[n] / (jiechengNA[k] * jiechengNA[n - k]))
						* tka[k] * otka[n - k];
				xf = xf + al.get(k).x * xs;
				yf = yf + al.get(k).y * xs;
			}
			result.add(new BNPosition(xf, yf));
		}

		return result;
	}

	// ׳˵ķ
	public static long jiecheng(int n) {
		long result = 1; // һlong͵ı
		if (n == 0) // 0Ľ׳Ϊ1
		{
			return 1;
		}

		for (int i = 2; i <= n; i++) { // ڵ2Ľ׳
			result = result * i;
		}

		return result; // ؽ
	}
}
