package com.gles.view.util;

import java.io.IOException;
import java.io.InputStream;

import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.opengl.GLES20;
import android.opengl.GLUtils;

/**
 * ɹ<br>
 * <p>
 * ע㣺ʹõͼƬ ߱Ϊ 2nηĳߴͼƬȻ޷ʾ⣡<br>
 * 
 * eg: ʹõĿֵ24163264128...2Nη
 * 
 * @author qianjunping
 * 
 */
public class JqTextureUtil {

	private static JqTextureUtil mJqTextureUtil;
	private static Resources res;

	/**
	 * ע㣺ʹõͼƬ ߱Ϊ 2nηĳߴͼƬȻܻ޷ʾ⣡
	 * 
	 * @param res
	 * @return
	 */
	public static JqTextureUtil getInstance(Resources res) {
		JqTextureUtil.res = res;
		if (mJqTextureUtil == null) {
			mJqTextureUtil = new JqTextureUtil();
		}
		return mJqTextureUtil;
	}

	/**
	 * 2Dͼ
	 * 
	 * @param drawableId
	 *            ͼƬԴId
	 * @return
	 */
	public int create2DTexture(int drawableId) {

		// ID
		int[] textures = new int[1];
		GLES20.glGenTextures(1, // id
				textures, // id
				0 // ƫ
		);
		int textureId = textures[0];
		// ɵĿ󶨵ǰ2Dͨ
		GLES20.glBindTexture(GLES20.GL_TEXTURE_2D, textureId);
		// νĬϼst 췽ʽĬãMIN  MAG ʽĬ
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D,
				GLES20.GL_TEXTURE_MIN_FILTER, GLES20.GL_NEAREST);
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D,
				GLES20.GL_TEXTURE_MAG_FILTER, GLES20.GL_LINEAR);
		// ķʽĬ϶Ϊظ
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D, GLES20.GL_TEXTURE_WRAP_S,
				GLES20.GL_REPEAT);
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D, GLES20.GL_TEXTURE_WRAP_T,
				GLES20.GL_REPEAT);

		Bitmap bitmapTmp = getBit(drawableId);

		// bitmapӦõ2Dͨǰ󶨵
		GLUtils.texImage2D(GLES20.GL_TEXTURE_2D, // 
				0, // ĲΣ0ʾͼ㣬Ϊֱͼ
				bitmapTmp, // ͼ
				0 // ߿ߴ
		);
		bitmapTmp.recycle(); // سɹͷͼƬ
		return textureId;
	}

	public int create2DTexture(int drawableId, int minFilter, int magFilter,
			int glWrapS, int glWrapT) {
		// ID
		int[] textures = new int[1];
		GLES20.glGenTextures(1, // id
				textures, // id
				0 // ƫ
		);
		int textureId = textures[0];
		// ɵĿ󶨵ǰ2Dͨ
		GLES20.glBindTexture(GLES20.GL_TEXTURE_2D, textureId);
		// νĬϼst 췽ʽĬãMIN  MAG ʽĬ
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D,
				GLES20.GL_TEXTURE_MIN_FILTER, minFilter);
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D,
				GLES20.GL_TEXTURE_MAG_FILTER, magFilter);
		// ķʽĬ϶Ϊظ
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D, GLES20.GL_TEXTURE_WRAP_S,
				glWrapS);
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D, GLES20.GL_TEXTURE_WRAP_T,
				glWrapT);

		Bitmap bitmapTmp = getBit(drawableId);
		// bitmapӦõ2Dͨǰ󶨵
		GLUtils.texImage2D(GLES20.GL_TEXTURE_2D, // 
				0, // ĲΣ0ʾͼ㣬Ϊֱͼ
				bitmapTmp, // ͼ
				0 // ߿ߴ
		);
		bitmapTmp.recycle(); // سɹͷͼƬ
		return textureId;
	}

	/**
	 *  MipMap ͵ͼ ģԶ<br>
	 * ҪͼƬ
	 * 
	 * @param drawableId
	 * @return
	 */
	public int create2DMipMapTexture(int drawableId) {
		int[] textures = new int[1];
		GLES20.glGenTextures(1, // id
				textures, // id
				0 // ƫ
		);
		int textureId = textures[0];
		GLES20.glBindTexture(GLES20.GL_TEXTURE_2D, textureId);
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D,
				GLES20.GL_TEXTURE_MIN_FILTER, GLES20.GL_NEAREST_MIPMAP_NEAREST);
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D,
				GLES20.GL_TEXTURE_MAG_FILTER, GLES20.GL_LINEAR_MIPMAP_LINEAR);
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D, GLES20.GL_TEXTURE_WRAP_S,
				GLES20.GL_REPEAT);
		GLES20.glTexParameterf(GLES20.GL_TEXTURE_2D, GLES20.GL_TEXTURE_WRAP_T,
				GLES20.GL_REPEAT);
		// ͨͼƬ
		Bitmap bitmapTmp = getBit(drawableId);
		// ʵʼ
		GLUtils.texImage2D(GLES20.GL_TEXTURE_2D, // ͣOpenGL
													// ESбΪGL10.GL_TEXTURE_2D
				0, // ĲΣ0ʾͼ㣬Ϊֱͼ
				bitmapTmp, // ͼ
				0 // ߿ߴ
		);
		bitmapTmp.recycle(); // سɹͷͼƬ

		GLES20.glGenerateMipmap(GLES20.GL_TEXTURE_2D);
		return textureId;
	}

	/**
	 * Զзķ
	 * 
	 * @param bw
	 *            зֵĿ
	 * @param bh
	 *            зֵĿ
	 * 
	 * @param widthLength
	 *            ܿ
	 * 
	 * @param heightLength
	 *            ܸ߶
	 * @return
	 */
	public static float[] generateTexCoor(int bw, int bh, float widthLength,
			float heightLength) {
		float[] result = new float[bw * bh * 6 * 2];
		float sizew = widthLength / bw;// 
		float sizeh = heightLength / bh;// 
		int c = 0;
		for (int i = 0; i < bh; i++) {
			for (int j = 0; j < bw; j++) {
				// ÿһΣιɣ㣬12
				float s = j * sizew;
				float t = i * sizeh;

				result[c++] = s;
				result[c++] = t;

				result[c++] = s;
				result[c++] = t + sizeh;

				result[c++] = s + sizew;
				result[c++] = t;

				result[c++] = s + sizew;
				result[c++] = t;

				result[c++] = s;
				result[c++] = t + sizeh;

				result[c++] = s + sizew;
				result[c++] = t + sizeh;

			}
		}
		return result;
	}

	private Bitmap getBit(int drawableId) {

		Bitmap bitmapTmp = null;
		InputStream is = res.openRawResource(drawableId);
		try {
			bitmapTmp = BitmapFactory.decodeStream(is);
		} finally {
			try {
				if (is != null)
					is.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return bitmapTmp;
	}

	private JqTextureUtil() {

	}

}
